/*
 *                         OpenSplice DDS
 *
 *   This software and documentation are Copyright 2006 to 2012 PrismTech
 *   Limited and its licensees. All rights reserved. See file:
 *
 *                     $OSPL_HOME/LICENSE
 *
 *   for full copyright notice and license terms.
 *
 */
#ifndef OSPL_DDS_CORE_VALUE_HPP_
#define OSPL_DDS_CORE_VALUE_HPP_

/**
 * @file
 */

/*
 * OMG PSM class declaration
 */
#include <spec/dds/core/Value.hpp>

// Implementation
namespace dds
{
namespace core
{

template <typename D>
Value<D>::Value() { }

template <typename D>
Value<D>::Value(const Value& p) : d_(p.d_) { }

template <typename D>
template <typename ARG>
Value<D>::Value(const ARG& arg) : d_(arg) { }

template <typename D>
template <typename ARG1, typename ARG2>
Value<D>::Value(const ARG1& arg1, const ARG2& arg2) : d_(arg1, arg2) { }

template <typename D>
template <typename ARG1, typename ARG2, typename ARG3>
Value<D>::Value(const ARG1& arg1, const ARG2& arg2, const ARG3& arg3)
    : d_(arg1, arg2, arg3) { }

template <typename D>
template <typename ARG1, typename ARG2, typename ARG3, typename ARG4>
Value<D>::Value(const ARG1& arg1, const ARG2& arg2, const ARG3& arg3, const ARG4& arg4)
    : d_(arg1, arg2, arg3, arg4) { }

template <typename D>
template <typename ARG1, typename ARG2, typename ARG3, typename ARG4, typename ARG5>
Value<D>::Value(const ARG1& arg1, const ARG2& arg2, const ARG3& arg3, const ARG4& arg4, const ARG5& arg5)
    : d_(arg1, arg2, arg3, arg4, arg5) { }

template <typename D>
template <typename ARG1, typename ARG2, typename ARG3, typename ARG4, typename ARG5, typename ARG6>
Value<D>::Value(const ARG1& arg1, const ARG2& arg2, const ARG3& arg3, const ARG4& arg4, const ARG5& arg5, const ARG6& arg6)
    : d_(arg1, arg2, arg3, arg4, arg5, arg6) { }

template <typename D>
Value<D>::~Value() { }

template <typename D>
Value<D>& Value<D>::operator=(const Value& other)
{
    if (this != &other)
    {
        d_ = other.d_;
    }
    return *this;
}

template <typename D>
bool Value<D>::operator==(const Value& other) const
{
    return (d_ == other.d_);
}

template <typename D>
bool Value<D>::operator !=(const Value& other) const
{
    return !(d_ == other.d_);
}

template <typename D>
const D* Value<D>::operator->() const
{
    return &d_;
}

template <typename D>
D* Value<D>::operator->()
{
    return &d_;
}

template <typename D>
const D& Value<D>::delegate() const
{
    return d_;
}

template <typename D>
D& Value<D>::delegate()
{
    return d_;
}

template <typename D>
Value<D>::operator D&()
{
    return d_;
}

template <typename D>
Value<D>::operator const D& () const
{
    return d_;
}

}
}
// End of implementation

#endif /* OSPL_DDS_CORE_VALUE_HPP_ */
